package com.ccnode.codegenerator.view.b;

package .tmp;

import com.ccnode.codegenerator.aa.b;
import com.ccnode.codegenerator.aa.c;
import com.ccnode.codegenerator.ae.D;
import com.ccnode.codegenerator.ae.T;
import com.ccnode.codegenerator.datasourceToolWindow.dbInfo.DatabaseInfo;
import com.ccnode.codegenerator.o.b.a.b;
import com.ccnode.codegenerator.view.b.m;
import com.google.common.collect.ImmutableList;
import com.google.common.collect.ImmutableListMultimap;
import com.google.common.collect.Lists;
import com.google.common.collect.UnmodifiableIterator;
import com.intellij.codeInsight.completion.CompletionContributor;
import com.intellij.codeInsight.completion.CompletionParameters;
import com.intellij.codeInsight.completion.CompletionResultSet;
import com.intellij.codeInsight.completion.CompletionType;
import com.intellij.codeInsight.lookup.LookupElement;
import com.intellij.codeInsight.lookup.LookupElementBuilder;
import com.intellij.openapi.components.ServiceManager;
import com.intellij.openapi.editor.Document;
import com.intellij.openapi.project.Project;
import com.intellij.openapi.util.TextRange;
import com.intellij.psi.PsiDocumentManager;
import com.intellij.psi.PsiElement;
import com.intellij.psi.PsiFile;
import com.intellij.psi.PsiMethod;
import com.intellij.psi.xml.XmlFile;
import com.intellij.psi.xml.XmlTag;
import com.intellij.psi.xml.XmlTagValue;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import org.apache.commons.lang3.StringUtils;
import org.jetbrains.annotations.NotNull;

public class d extends CompletionContributor {
  private static ImmutableListMultimap<String, String> a = ImmutableListMultimap.<String, String>builder()
    .put("s", "select")
    .put("S", "SELECT")
    .put("i", "insert into")
    .put("I", "INSERT INTO")
    .put("u", "update")
    .put("U", "UPDATE")
    .put("d", "delete")
    .put("D", "DELETE")
    .put("j", "join")
    .put("J", "JOIN")
    .put("i", "inner join")
    .put("I", "INNER JOIN")
    .put("l", "left join")
    .put("L", "LEFT JOIN")
    .put("o", "on")
    .put("O", "ON")
    .put("m", "max")
    .put("M", "MAX")
    .put("m", "min")
    .put("M", "MIN")
    .put("c", "count")
    .put("C", "COUNT")
    .put("d", "distinct")
    .put("D", "DISTINCT")
    .put("f", "from")
    .put("F", "FROM")
    .put("o", "order by")
    .put("O", "ORDER BY")
    .put("d", "desc")
    .put("d", "DESC")
    .put("w", "where")
    .put("W", "WHERE")
    .put("r", "right join")
    .put("R", "RIGHT JOIN")
    .put("l", "limit")
    .put("L", "LIMIT")
    .put("h", "having")
    .put("H", "HAVING")
    .put("g", "group by")
    .put("G", "GROUP BY")
    .put("v", "values")
    .put("V", "VALUES")
    .put("d", "duplicate")
    .put("D", "DUPLICATE")
    .put("f", "for update")
    .put("F", "FOR UPDATE")
    .put("a", "asc")
    .put("A", "ASC")
    .put("u", "union")
    .put("U", "UNION")
    .put("r", "replace")
    .put("R", "REPLACE")
    .put("u", "using")
    .put("U", "USING")
    .build();
  
  private static List<String> a = Lists.newArrayList(new String[] { 
        "CHAR", "VARCHAR", "LONGVARCHAR", "BIT", "TINYINT", "SMALLINT", "INTEGER", "BIGINT", "REAL", "DOUBLE", 
        "FLOAT", "DECIMAL", "NUMERIC", "DATE", "TIME", "TIMESTAMP" });
  
  public void fillCompletionVariants(@NotNull CompletionParameters paramCompletionParameters, @NotNull CompletionResultSet paramCompletionResultSet) {
    PsiElement psiElement1 = paramCompletionParameters.getOriginalPosition();
    if (psiElement1 == null)
      return; 
    XmlTag xmlTag1 = D.a.a(psiElement1, true);
    if (xmlTag1 == null)
      return; 
    PsiElement psiElement2 = psiElement1.getParent();
    if (psiElement2 == null || !(psiElement2 instanceof com.intellij.psi.xml.XmlText))
      return; 
    PsiElement psiElement3 = paramCompletionParameters.getPosition();
    String str1 = psiElement3.getText();
    int i = paramCompletionParameters.getEditor().getCaretModel().getCurrentCaret().getSelectionStart();
    int j = paramCompletionParameters.getPosition().getTextRange().getStartOffset();
    if (i - j < 0)
      return; 
    String str2 = str1.substring(0, i - j);
    PsiFile psiFile = paramCompletionParameters.getOriginalFile();
    if (!(psiFile instanceof XmlFile))
      return; 
    XmlFile xmlFile = (XmlFile)psiFile;
    XmlTag xmlTag2 = xmlFile.getRootTag();
    if (xmlTag2 == null)
      return; 
    if (!xmlTag2.getName().equals("mapper"))
      return; 
    int k = str2.lastIndexOf("#{");
    if (k != -1) {
      String str = str2.substring(k);
      if (!str.contains("}")) {
        a(paramCompletionResultSet, psiElement1, str2, xmlFile, k);
        return;
      } 
    } 
    int m = str2.lastIndexOf("`");
    if (m != -1 && m > str2.length() - 10) {
      String str = str2.substring(m + 1);
      XmlTag[] arrayOfXmlTag = xmlTag2.getSubTags();
      ArrayList<b> arrayList = new ArrayList();
      for (XmlTag xmlTag : arrayOfXmlTag) {
        if (xmlTag.getName().equals("resultMap"))
          arrayList.addAll(a(xmlTag)); 
      } 
      Set<String> set = b(arrayList);
      int n = a(str2);
      set.forEach(paramString3 -> {
            boolean bool = paramString3.startsWith(paramString1);
            if (bool)
              paramCompletionResultSet.addElement((LookupElement)LookupElementBuilder.create(paramString2.substring(paramInt1, paramInt2 + 1) + paramString2.substring(paramInt1, paramInt2 + 1) + "`")); 
          });
    } 
    XmlTag xmlTag3 = D.a.a(psiElement1, false);
    if (xmlTag3 != null) {
      String str3 = xmlTag3.getText();
      XmlTagValue xmlTagValue = xmlTag3.getValue();
      Document document = PsiDocumentManager.getInstance(paramCompletionParameters.getEditor().getProject()).getDocument((PsiFile)xmlFile);
      int n = xmlTagValue.getTextRange().getStartOffset();
      if (i < n)
        return; 
      String str4 = document.getText(new TextRange(n, i));
      String str5 = document.getText(new TextRange(i, xmlTagValue.getTextRange().getEndOffset()));
      b b = a(paramCompletionParameters.getEditor().getProject(), str2, str4, str5, xmlTagValue.getText(), i - n, paramCompletionParameters
          .getCompletionType(), xmlTag3, xmlFile);
      m m1 = (m)ServiceManager.getService(b
          .a(), m.class);
      DatabaseInfo databaseInfo = m1.a();
      c c = (new com.ccnode.codegenerator.aa.d(b, databaseInfo)).a();
      if (c.a().size() > 0) {
        for (LookupElement lookupElement : c.a())
          paramCompletionResultSet.addElement(lookupElement); 
        return;
      } 
    } 
    if (str2.length() == 1) {
      ImmutableList<?> immutableList = a.get(str2);
      for (UnmodifiableIterator<?> unmodifiableIterator = immutableList.iterator(); unmodifiableIterator.hasNext(); ) {
        String str = (String)unmodifiableIterator.next();
        paramCompletionResultSet.addElement((LookupElement)LookupElementBuilder.create(str + " "));
      } 
    } 
  }
  
  private void a(@NotNull CompletionResultSet paramCompletionResultSet, PsiElement paramPsiElement, String paramString, XmlFile paramXmlFile, int paramInt) {
    if (paramString.endsWith(",")) {
      int j = a(paramString);
      String str = "";
      if (j != -1)
        str = paramString.substring(j); 
      for (String str3 : a)
        paramCompletionResultSet.addElement((LookupElement)LookupElementBuilder.create(str + "jdbcType=" + str)); 
      return;
    } 
    PsiMethod psiMethod = D.a.a(paramPsiElement, paramXmlFile);
    if (psiMethod == null)
      return; 
    List list = T.a.b(psiMethod);
    String str1 = paramString.substring(paramInt + 2);
    int i = a(paramString);
    String str2 = "";
    if (i != -1)
      str2 = paramString.substring(i, paramInt + 2); 
    for (String str : list) {
      if (str.startsWith(str1))
        paramCompletionResultSet.addElement((LookupElement)LookupElementBuilder.create(str2 + str2 + "}")); 
    } 
  }
  
  private b a(Project paramProject, String paramString1, String paramString2, String paramString3, String paramString4, int paramInt, CompletionType paramCompletionType, XmlTag paramXmlTag, XmlFile paramXmlFile) {
    b b = new b();
    b.a(paramInt);
    b.a(paramString2);
    b.b(paramString3);
    b.c(paramString4);
    b.d(paramString1);
    b.a(paramProject);
    b.a(paramCompletionType);
    b.a(paramXmlTag);
    b.a(paramXmlFile);
    return b;
  }
  
  private static int a(String paramString) {
    for (byte b = 0; b < paramString.length(); b++) {
      if (Character.isLetterOrDigit(paramString.charAt(b)))
        return b; 
    } 
    return -1;
  }
  
  private static Set<String> a(List<b> paramList) {
    HashSet<String> hashSet = new HashSet();
    for (b b : paramList) {
      if (StringUtils.isNotBlank(b.getField()))
        hashSet.add(b.getField()); 
    } 
    return hashSet;
  }
  
  private static Set<String> b(List<b> paramList) {
    HashSet<String> hashSet = new HashSet();
    for (b b : paramList) {
      if (StringUtils.isNotBlank(b.getColumn()))
        hashSet.add(b.getColumn()); 
    } 
    return hashSet;
  }
  
  private static List<b> a(XmlTag paramXmlTag) {
    ArrayList<b> arrayList = new ArrayList();
    if (paramXmlTag.getSubTags() != null)
      for (XmlTag xmlTag : paramXmlTag.getSubTags()) {
        b b = new b();
        String str1 = xmlTag.getAttributeValue("column");
        String str2 = xmlTag.getAttributeValue("property");
        b.setField(str2);
        b.setColumn(str1);
        arrayList.add(b);
      }  
    return arrayList;
  }
}
